var app = angular.module("famous", ["ngRoute", "longPress", "famousControllers", "famousServices", "famousServicesViews", "famousServicesLang", "famousFilters"]);
app.config(['$routeProvider','$controllerProvider', function($routeProvider, $controllerProvider){
	
	$routeProvider.when("/main", {
		templateUrl: 'app/pages/main/main.html',
	}).when("/login", {
		templateUrl: 'app/pages/login/login.html',
		controller: 'loginCtrl'
	}).when("/tasks", {
		templateUrl: 'app/pages/tasks/tasks.html',
	}).when("/earn", {
		templateUrl: 'app/pages/earn/earn.html',
		controller: 'earnCtrl'
	}).when("/bid_like", {
		templateUrl: 'app/pages/bid_like/bid_like.html',
		controller: 'bidLikeCtrl'
	}).when("/bid_subs", {
		templateUrl: 'app/pages/bid_subs/bid_subs.html',
		controller: 'bidSubsCtrl'
	}).when("/donate/:id", {
		templateUrl: 'app/pages/donate/donate.html',
		controller: 'donateCtrl'
	}).when("/donate_vip", {
		templateUrl: 'app/pages/donate_vip/donate_vip.html',
		controller: 'donateVipCtrl'
	}).when("/settings", {
		templateUrl: 'app/pages/settings/settings.html',
		controller: 'settingsCtrl'
	}).when("/news", {
		templateUrl: 'app/pages/news/news.html',
		controller: 'newsCtrl'
	}).when("/authtrouble", {
		templateUrl: 'app/pages/authtrouble/authtrouble.html',
		controller: 'authtroubleCtrl'
	}).when("/top", {
		templateUrl: 'app/pages/top/top.html',
		controller: 'topCtrl'
	}).when("/lvlprize", {
		templateUrl: 'app/pages/lvlprize/lvlprize.html',
		controller: 'lvlPrizeCtrl'
	}).when("/privacy", {
		templateUrl: 'app/pages/privacy/privacy.html',
		controller: 'privacyCtrl'
	}).when("/otheracc/:nickname", {
		templateUrl: 'app/pages/otheracc/otheracc.html'
	}).when("/autotask", {
		templateUrl: 'app/pages/autotask/autotask.html',
		controller: 'autotaskCtrl'
	})
	.otherwise({
		redirectTo: '/login'
	});
}]);

app.config(['$provide', function ($provide){
	$provide.decorator('$exceptionHandler', ['$delegate', function($delegate) {
		return function (exception, cause){
			$delegate(exception, cause);
			Manager.instance.getConnector().error(exception.message, exception.stack, function(){});
		};
	}]);
}]);

window.onload = function(){}