Lang.getBidLike = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				likesButText: "Likes",
				subsButText: "Followers",
				bidLikeNoQuestText: "You have no posts yet",

				listBut: "From list",
				linkBut: "Link",

				linkLikePh: "Link on post",
				likesPh:  "Enter likes count",
				diamondsText: "Diamonds",
				startText: "Order"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				likesButText: "Лайки",
				subsButText: "Подписчики",
				bidLikeNoQuestText: "У Вас пока нет ни одного поста",

				listBut: "Из списка",
				linkBut: "По ссылке",

				linkLikePh: "Ссылка на пост",
				likesPh:  "Введите количество лайков",
				diamondsText: "Диаманты",
				startText: "Заказать"
			};
			break;
		case Constant.DE_LANG:
			lang = {
				likesButText: "Likes",
				subsButText: "Subskription",
				bidLikeNoQuestText: "Sie haben noch keine Fragen",

				listBut: "aus der Liste",
				linkBut: "durch den Link",

				linkLikePh: "Link auf die Beitrag",
				likesPh: "Fuehren Sie die Likesanzahl zu",
				diamondsText: "Diamanten",
				startText: "bestellen"
			};
			break;
		case Constant.ES_LANG:
			lang = {
				likesButText: "Me gusta",
				subsButText: "Suscripciones",
				bidLikeNoQuestText: "No tiene ninguna pregunta todavia",

				listBut: "De la lista",
				linkBut: "Enlace",

				linkLikePh: "Enlace al post",
				likesPh: "Inserte  el numero de me gusta",
				diamondsText: "Diamantos",
				startText: "Encargar"
			};
			break;
		case Constant.FR_LANG:
			lang = {
				likesButText: "Comme",
				subsButText: "Abonnements",
				bidLikeNoQuestText: "Vous n'avez pas encore de questions",

				listBut: "de la liste",
				linkBut: "suivre le lien",

				linkLikePh: "Lien vers Poster",
				likesPh: "Saisissez le nombre de comme",
				diamondsText: "Diamants",
				startText: "Commander"
			};
			break;
		case Constant.IT_LANG:
			lang = {
				likesButText: "Likes",
				subsButText: "Abbonamento",
				bidLikeNoQuestText: "Lei per ora non ha nessuna domanda",

				listBut: "Dalla lista",
				linkBut: "Sul collegamento",

				linkLikePh: "Collegamento al post",
				likesPh: "La quantità dei likes",
				diamondsText: "Diamanti",
				startText: "Ordinare"
			};
			break;
		case Constant.TR_LANG:
			lang = {
				likesButText: "Like",
				subsButText: "Takipçiler",
				bidLikeNoQuestText: "Sorunuz yok",

				listBut: "Listeden",
				linkBut: "Linkden",

				linkLikePh: "Post bağlantı",
				likesPh: "Like sayısını girin",
				diamondsText: "Elmaslar",
				startText: "Sipariş"
			};
			break;
	}
	return lang;
}

// BID LIKE LANGS
services_lang.service("$bidLikeLang", ["$lang", function($lang){
	this.setLang = function($scope){
		$lang.getLang(Constant.BID_LIKE_VIEW, function(lang){
			$scope.likesButText = lang.likesButText;
			$scope.subsButText = lang.subsButText;
			$scope.bidLikeNoQuestText = lang.bidLikeNoQuestText;

			$scope.listBut = lang.listBut;
			$scope.linkBut = lang.linkBut;

			$scope.linkLikePh = lang.linkLikePh;
			$scope.likesPh = lang.likesPh;
			$scope.diamondsText = lang.diamondsText;
			$scope.startText = lang.startText;

			$scope.$applyAsync();
		});
	}
}]);