services_views.service("$bidLikeView", ["$manager", "$action", "$dialogView", "$longtabView", "$heighter", 
					function($manager, $action, $dialogView, $longtabView, $heighter){
	var self = this;
	var curScrollTop = 0;
	var isNewPosts = true;	// don't check new posts while cur posts loading

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "bid":
				this.bidOk($scope, response);
				break;
			case "moreFields":
				this.moreFieldsOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "bid":
				this.bidErr($scope, response);
				break;
			case "moreFields":
				this.moreFieldsErr($scope, response);
				break;
		}
	}
	
	this.moreFieldsOk = function($scope, response){
		$scope.posts = $manager.instance.getUser().getPosts();
		// send posts to longtab view
		$longtabView.putPosts($scope.posts);

		newPostsLoad(false);
	}
	
	this.moreFieldsErr = function($scope, response){
		newPostsLoad(false);
		switch(response.data.errorCode){
			case Constant.ERR_CODE_BROWSER_UPDATE:
				$dialogView.showToast($dialogView.strings.readErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.bidOk = function($scope, response){
		self.setButAnim(false);
		$dialogView.showToast($dialogView.strings.bidOk);
		$dialogView.setCash(response.data.cash);
	}
	
	this.bidErr = function($scope, response){
		self.setButAnim(false);
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_BID:
				$dialogView.showToast($dialogView.strings.bidFail);
				break;
			case Constant.ERR_CODE_BROWSER_BID:
				$dialogView.showToast($dialogView.strings.mhFail);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
			case Constant.ERR_CODE_BROWSER_PRIVATE:
				$dialogView.showPrivateAcc();
				break;
		}
	}

	// set every post and set anim to it
	this.setPosts = function(index, src){
		$(".bid-like-list-info .quest-block .quest-elem-block").eq(index).css("background-image", "url(" + src + ")");

		var height = (window.innerWidth * 32 / 100) + "px";
		$(".bid-like-list-info .quest-block .quest-elem-block").eq(index).css("line-height", height);
		$(".bid-like-list-info .quest-block .quest-elem-block").eq(index).css("height", height);

		if(index % 3 == 0){
			$(".bid-like-list-info .quest-block .quest-elem-block").eq(index).css("float", "left");
		}else if(index % 3 == 2){
			$(".bid-like-list-info .quest-block .quest-elem-block").eq(index).css("float", "right");
		}else{
			$(".bid-like-list-info .quest-block .quest-elem-block").eq(index).css("float", "left");
			$(".bid-like-list-info .quest-block .quest-elem-block").eq(index).css("margin-left", "2%");
		}
		$(".bid-like-list-info .quest-block .quest-elem-block").eq(index).removeClass("none");
	}
	
	this.setInfo = function($scope){
		$scope.posts = $manager.instance.getUser().getPosts();
		// send posts to longtab view
		$longtabView.putPosts($scope.posts);
		// set notasks image if has no posts
		if($scope.posts.length == 0){
			$('.bid-like-notasks-block:first').removeClass("none");
			$('.bid-like-list-block:first').addClass("none");
		}
	}

	// switch buttons on bottom
	this.switcherLikes = function($scope, num){
		switch(num){
			case 1:
				// switch buttons
				$('#butLikeList').addClass("bid-but-active");
				$('#butLikeLink').removeClass("bid-but-active");

				// switch content
				$('#blockLikeList').removeClass("none");
				$('#blockLikeLink').addClass("none");

				if($scope.posts.length == 0)
					$('.bid-like-notasks-block:first').removeClass("none");
			break;
			case 2:
				$('#butLikeList').removeClass("bid-but-active");
				$('#butLikeLink').addClass("bid-but-active");

				$('#blockLikeList').addClass("none");
				$('#blockLikeLink').removeClass("none");

				$('.bid-like-notasks-block:first').addClass("none");
			break;
		}
	}
	
	this.setPrice = function($scope, count){
		if(count >= 0 && count != ''){
			$scope.price = count * Constant.LIKE_PRICE;
		}else{
			$scope.price = "";
		}
	}

	// show or hide loading in button
	this.setButAnim = function(isAnim){
		if(isAnim){
			$("#likeSend").addClass("none");
			$("#likeSendAnim").removeClass("none");
		}else{
			$("#likeSend").removeClass("none");
			$("#likeSendAnim").addClass("none");
		}
	}

	function initScroll(){
		document.querySelector(".bid-like-list-block").addEventListener("scroll", function(){
			// check new posts
			checkNewPosts();
			// hide earn but while scrooling
			hideShowEarnBut();
		});
	}

	function hideShowEarnBut(){
		if($(".bid-like-list-block").scrollTop() > curScrollTop){
			$(".goearn-but-block").css("display", "none");
			curScrollTop = $(".bid-like-list-block").scrollTop();
		}
		if($(".bid-like-list-block").scrollTop() < curScrollTop){
			$(".goearn-but-block").css("display", "inline");
			curScrollTop = $(".bid-like-list-block").scrollTop();
		}
	}

	function checkNewPosts(){
		var contentSize = $heighter.setHeight(Constant.MAJOR_VIEW, [$(".bid-select"), $(".bid-buttons")]);

		if(($(".bid-like-list-block").scrollTop() + contentSize) >= ($(".bid-like-list-info").height() - 5)){
			if($manager.instance.getUser().hasMorePosts() && isNewPosts){
				newPostsLoad(true);

				var appElement = document.querySelector('[ng-controller=bidLikeCtrl]');
				var $scope = angular.element(appElement).scope();
				$action.moreFields($manager.instance.getUser(), $scope);
			}
		}
	}

	// show or hide loading new images in "show more" button
	function newPostsLoad(type){
		if(type){
			$(".bid-like-more-block:first").removeClass("none");
			// scroll to bottom
			$(".bid-like-list-block").scrollTop($(".bid-like-list-info").height());
			isNewPosts = false;
		}else{
			// minus loadlock height for scroll
			curScrollTop -= $(".bid-like-more-block:first").outerHeight(true);
			$(".bid-like-more-block:first").addClass("none");
			isNewPosts = true;
		}
	}

	function setContentSize(){
		$(".bid-like-list-block").css("height", $heighter.setHeight(Constant.MAJOR_VIEW, [$(".bid-select"), $(".bid-buttons")]));

		$(".bid-like-notasks-block").css("height", $heighter.setHeight(Constant.MAJOR_VIEW, [$(".bid-select"), $(".bid-buttons")]));

		$(".bid-like-link-block").css("height", $heighter.setHeight(Constant.MAJOR_VIEW, [$(".bid-select"), $(".bid-buttons")]));
	}

	//init all functions in view
	this.initViewParams = function(){
		// show go to earn button
		$(".goearn-but-block").css("display", "inline");
		$(".goearn-but-block").addClass("goearn-but-bottom");

		// show navigation bar
		$(".navigation").removeClass("none");

		// set height of main content
		setContentSize();

		// init content scroll
		initScroll();
	}
}]);