services_views.service("$bidSubsView", ["$manager", "$dialogView", "$heighter", function($manager, $dialogView, $heighter){
	var self = this;

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "bid":
				this.bidOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "bid":
				this.bidErr($scope, response);
				break;
		}
	}
	
	this.bidOk = function($scope, response){
		this.setButAnim(); 											//without params - remove all animations
		$dialogView.showToast($dialogView.strings.bidOk);
		$dialogView.setCash(response.data.cash);
	}
	
	this.bidErr = function($scope, response){
		this.setButAnim();											//without params - remove all animations
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_BID:
				$dialogView.showToast($dialogView.strings.bidFail);
				break;
			case Constant.ERR_CODE_BROWSER_BID:
				$dialogView.showToast($dialogView.strings.mhFail);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}

	this.checkSubscribeSetting = function(){
		if($manager.instance.getUser().getSetting(Config.SUBSCRIBE_SETTING) == 1 || $manager.instance.getUser().getPremium()){
			$(".bid-subs-accept-block:first").addClass("none");
			$('#blockSubsAcc').removeClass("none");
			$("#subsBotButtons").removeClass("none");
			$(".goearn-but-block").css("display", "inline");
		}else{
			$(".bid-subs-accept-block:first").removeClass("none");
			$("#subsBotButtons").addClass("none");
			$(".goearn-but-block").css("display", "none");
		}
	}

	this.acceptSubscribe = function(){
		$(".bid-subs-accept-block:first").addClass("none");
		$('#blockSubsAcc').removeClass("none");
		$("#subsBotButtons").removeClass("none");
		$(".goearn-but-block").css("display", "inline");

		var val = $manager.instance.getUser().getSetting(Config.SUBSCRIBE_SETTING) == 1 ? 0 : 1;
		$manager.instance.getDataManager().setSetting(Config.SUBSCRIBE_SETTING, val, function(){});
	}

	// switch buttons on bottom
	this.switcherSubs = function(num){
		switch(num){
			case 1:
				//переключить кнопки
				$('#butSubsAcc').addClass("bid-but-active");
				$('#butSubsLink').removeClass("bid-but-active");

				//переключить контент
				$('#blockSubsAcc').removeClass("none");
				$('#blockSubsLink').addClass("none");
			break;
			case 2:
				$('#butSubsAcc').removeClass("bid-but-active");
				$('#butSubsLink').addClass("bid-but-active");

				$('#blockSubsAcc').addClass("none");
				$('#blockSubsLink').removeClass("none");
			break;
		}
	}
	
	this.setPrice = function($scope, count, numPanel){
		switch(numPanel){
			case 1:
				if(count >= 0 && count != ''){
					$scope.priceAcc = count * Constant.SUBSCRIBE_PRICE;
				}else{
					$scope.priceAcc = "";
				}
				break;
			case 2:
				if(count >= 0 && count != ''){
					$scope.priceLink = count * Constant.SUBSCRIBE_PRICE;
				}else{
					$scope.priceLink = "";
				}
				break;
		}
	}

	// show or hide loading in button
	this.setButAnim = function(num, isAnim){
		if(num == 1){
			if(isAnim){
				$("#subsAccSend").addClass("none");
				$("#subsAccSendAnim").removeClass("none");
			}else{
				$("#subsAccSend").removeClass("none");
				$("#subsAccSendAnim").addClass("none");
			}
		}else if(num == 2){
			if(isAnim){
				$("#subsLinkSend").addClass("none");
				$("#subsLinkSendAnim").removeClass("none");
			}else{
				$("#subsLinkSend").removeClass("none");
				$("#subsLinkSendAnim").addClass("none");
			}
		}else{
			$("#subsAccSendAnim").addClass("none");
			$("#subsLinkSendAnim").addClass("none");
			
			$("#subsAccSend").removeClass("none");
			$("#subsLinkSend").removeClass("none");
		}
	}

	function setContentSize(){
		$(".bid-subs-block").css("height", $heighter.setHeight(Constant.MAJOR_VIEW, [$(".bid-select"), $(".bid-buttons")]));

		$(".bid-subs-accept-block").css("height", $heighter.setHeight(Constant.MAJOR_VIEW, [$(".bid-select"), $(".bid-buttons")]));
	}

	//init all functions in view
	this.initViewParams = function(){
		// show go to earn button
		$(".goearn-but-block").css("display", "none");
		$(".goearn-but-block").addClass("goearn-but-bottom");

		// show navigation bar
		$(".navigation").removeClass("none");

		// set height of main content
		setContentSize();

		// check is user know, he will subscribe on people too
		this.checkSubscribeSetting();
	}
}]);