services_views.service("$donateVipView", ["$rootScope", "$manager", "$dialogView", "$heighter", function($rootScope, $manager, $dialogView, $heighter){
	var self = this;

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "store":
				this.storeOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "store":
				this.storeErr($scope, response);
				break;
		}
	}
	
	this.storeOk = function($scope, response){
		
	}
	
	this.storeErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_LOAD_STORE:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.render = function(product){
		Log.d("RENDER", product.alias + " " + product.price);
		$("#"+product.id+"_title").text(product.alias);
		$("#"+product.id+"_price").text(product.price);
		if(product.type == store.PAID_SUBSCRIPTION){
			if(product.owned){
				$("#"+product.id+"_status").text("owned");
			}else{
				$("#"+product.id+"_status").text("not owned");
			}
		}
	}

	function setContentSize(){
		$(".donate-vip-block").css("height", $heighter.setHeight(Constant.MINOR_VIEW));
	}

	// init all functions in view
	this.initViewParams = function(){
		// hide go to earn button
		$(".goearn-but-block").css("display", "none");
		$(".goearn-but-block").removeClass("goearn-but-bottom");

		// show navigation bar
		$(".navigation").addClass("none");

		// set height of main content
		setContentSize();
	}
}]);