controllers.controller("earnCtrl", ["$scope", "$rootScope", "$action", "$location", "$earnView", "$earnLang", "$manager", "$dialogView", "$way",
						function($scope, $rootScope, $action, $location, $earnView, $earnLang, $manager, $dialogView, $way){
	$rootScope.locationTitle = $dialogView.strings.earnTitle;
	$way.step($scope, "/earn");

	var isRunnable = $manager.instance.getBot().isRunnable();

	// set values in depending on the bot
	if(!isRunnable){
		$rootScope.earnedDeposit = $manager.instance.getBot().getEarned();
		$rootScope.stateDeposit = $manager.instance.getUser().getCash().getDeposit();
	}else{
		$rootScope.stateDeposit = $manager.instance.getUser().getCash().getDeposit() - $manager.instance.getBot().getEarned();
	}
	
	$scope.response = function(response){
		$earnView.manageView($scope, response);
	}

	$scope.back = function(){
		$way.goBack($scope);
	}

	$scope.playPause = function(){
		if(isRunnable){
			isRunnable = false;
			$action.stop($scope);
		}else{
			isRunnable = true;
			$action.run($scope, Constant.EARN_RUN);
		}
	}

	$scope.setFastMode = function(){
		$dialogView.vibrate(500);
		$earnView.setFastMode();
		if(!isRunnable){
			isRunnable = true;
			$action.run($scope, Constant.EARN_BOOST_RUN);
		}else{
			$action.setMode(Bot.FAST_EARN_MODE);
			$manager.instance.getUser().setFastReady(0);
		}
	}

	// set power of turbo
	$earnView.setPower($scope);
	$earnView.initViewParams();
	//set mainer on the rock
	$rootScope.setManAndDrill($manager.instance.getBot().getMode());
	// check if fast mode available
	$rootScope.checkFastModeBut($manager.instance.getUser().isFastReady());
	// set state of earning
	$earnView.setRunState(isRunnable);

	$earnLang.setLang($scope);
}]);