services_views.service("$earnView", ["$manager", "$rootScope", "$action", "$dialogView", function($manager, $rootScope, $action, $dialogView){
	var self = this;

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "run":
				this.runOk($scope, response);
				break;
			case "stop":
				this.stopOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "run":
				this.runErr($scope, response);
				break;
			case "stop":
				this.stopErr($scope, response);
				break;
		}
	}
	
	this.runOk = function($scope, response){
		if(response.type == Constant.EARN_BOOST_RUN){
			$action.setMode(Bot.FAST_EARN_MODE);
			$manager.instance.getUser().setFastReady(0);
		}
		this.setRunState(true);
	}

	this.runErr = function($scope, response){
		this.setRunState(false);

		switch(response.data.errorCode){
			case Constant.ERR_CODE_BOT_RUN:
				$dialogView.showToast($dialogView.strings.runErr);
				break;
		}
	}
	
	this.stopOk = function($scope, response){
		this.setRunState(false);
		$rootScope.stateDeposit = $manager.instance.getUser().getCash().getDeposit();
	}

	this.stopErr = function($scope, response){
		this.setRunState(true);
		
		switch(response.data.errorCode){
			case Constant.ERR_CODE_BOT_STOP:
				$dialogView.showToast($dialogView.strings.stopErr);
				break;
		}
	}

	$rootScope.setTaskTime = function(time){
		if(time == 0){
			if($(".earn-table-image:first").hasClass("none")){
				$(".earn-table-image:first").removeClass("none");
			}

			if(!$(".earn-table-num:first").hasClass("none")){
				$(".earn-table-num:first").addClass("none");
			}
		}else{
			if(!$(".earn-table-image:first").hasClass("none")){
				$(".earn-table-image:first").addClass("none");
			}

			if($(".earn-table-num:first").hasClass("none")){
				$(".earn-table-num:first").removeClass("none");
			}

			$(".earn-table-num:first").text(Math.floor(time / 1000));
		}
		
		self.showTaskTime(true);
	}

	this.showTaskTime = function(isShow){
		if(isShow){
			$(".earn-table-block:first").removeClass("none");
		}else{
			$(".earn-table-block:first").addClass("none");
		}
	}

	this.setRunState = function(isRunnable){
		if(isRunnable){
			$(".earn-action-play-image:first").addClass("none");
			$(".earn-action-pause-image:first").removeClass("none");

			self.setManAndDrillAnim(isRunnable);
		}else{
			$(".earn-action-play-image:first").removeClass("none");
			$(".earn-action-pause-image:first").addClass("none");

			self.showTaskTime(isRunnable);

			self.setManAndDrillAnim(isRunnable);
		}
	}

	// set text speed of turbo
	this.setPower = function($scope){
		switch(parseInt($manager.instance.user.getTurbo())){
			case 0:
				$scope.powerVal = "100%";
				break;
			case 4:
			case 1:
				$scope.powerVal = "300%";
				break;
			case 2:
				$scope.powerVal = "500%";
				break;
			case 3:
				$scope.powerVal = "1000%";
				break;
			case 5:
				$scope.powerVal = "5000%";
				break;
		}
	}

	this.setFastMode = function(){
		$(".earn-fastmode-but").addClass("none");

		// set Den
		$(".earn-man-image:first").attr("src", "app/pages/earn/images/earn_man_fast.png");
		$(".earn-man-image:first").addClass("earn-man-image4");

		// set gold drill
		$(".earn-drill-image:first").attr("src", "app/pages/earn/images/earn_drill_fast.png");
		$(".earn-drill-image:first").addClass("earn-drill-image4");
	}

	$rootScope.checkFastModeBut = function(isFastReady){
		if(isFastReady){
			$(".earn-fastmode-but").removeClass("none");
		}else{
			$(".earn-fastmode-but").addClass("none");
		}
	}

	$rootScope.setManAndDrill = function(modeRunnable){
		if(modeRunnable == Bot.FAST_EARN_MODE){
			// set Den
			$(".earn-man-image:first").attr("src", "app/pages/earn/images/earn_man_fast.png");
			$(".earn-man-image:first").addClass("earn-man-image-fast");

			// set gold drill
			$(".earn-drill-image:first").attr("src", "app/pages/earn/images/earn_drill_fast.png");
			$(".earn-drill-image:first").addClass("earn-drill-image-fast");

			return;
		}else{
			// remove classes for Den
			$(".earn-man-image:first").removeClass("earn-man-image-fast");
			$(".earn-drill-image:first").removeClass("earn-drill-image-fast");
		}
		// set miner by lvl and drill image size
		var lvl = $manager.instance.getUser().getXpInfo().getLvl();
		if(lvl < 10){
			$(".earn-man-image:first").attr("src", "images/earn_man1.png");
			$(".earn-man-image:first").addClass("earn-man-image1");

			$(".earn-drill-image:first").addClass("earn-drill-image1");
		}else if(lvl < 20){
			$(".earn-man-image:first").attr("src", "images/earn_man2.png");
			$(".earn-man-image:first").addClass("earn-man-image2");

			$(".earn-drill-image:first").addClass("earn-drill-image1");
		}else if(lvl < 30){
			$(".earn-man-image:first").attr("src", "images/earn_man3.png");
			$(".earn-man-image:first").addClass("earn-man-image3");

			$(".earn-drill-image:first").addClass("earn-drill-image2");
		}else if(lvl < 40){
			$(".earn-man-image:first").attr("src", "images/earn_man4.png");
			$(".earn-man-image:first").addClass("earn-man-image4");

			$(".earn-drill-image:first").addClass("earn-drill-image3");
		}else{
			$(".earn-man-image:first").attr("src", "images/earn_man5.png");
			$(".earn-man-image:first").addClass("earn-man-image5");

			$(".earn-drill-image:first").addClass("earn-drill-image4");
		}

		// set drill image by turbo
		switch(parseInt($manager.instance.user.getTurbo())){
			case 0:
				$(".earn-drill-image:first").attr("src", "app/pages/earn/images/earn_drill_default.png");
				break;
			case 1:
				$(".earn-drill-image:first").attr("src", "app/pages/earn/images/earn_drill_turbo1.png");
				break;
			case 2:
				$(".earn-drill-image:first").attr("src", "app/pages/earn/images/earn_drill_turbo2.png");
				break;
			case 3:
				$(".earn-drill-image:first").attr("src", "app/pages/earn/images/earn_drill_turbo3.png");
				break;
			case 4:
				$(".earn-drill-image:first").attr("src", "app/pages/earn/images/earn_drill_turbo1.png");
				break;
		}
	}

	this.setManAndDrillAnim = function(isRun){
		if(isRun){
			$(".earn-man-image").addClass("miner-action");
			$(".earn-drill-image").addClass("miner-action");
		}else{
			$(".earn-man-image").removeClass("miner-action");
			$(".earn-drill-image").removeClass("miner-action");
		}
	}

	//init all functions in view
	this.initViewParams = function(){
		// hide go to earn button
		$(".goearn-but-block").css("display", "none");

		// hide navigation bar
		$(".navigation").addClass("none");
	}
}]);