services_views.service("$loginView", ["$manager", "$location", "$dialogView", "$keyboardMonster", "$navView",
					  function($manager, $location, $dialogView, $keyboardMonster, $navView){
	var self = this;

	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "auth":
				this.authOk($scope, response);
				break;
			case "load":
				this.loadOk($scope, response);
				break;
			case "show":
				this.showOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "auth":
				this.authErr($scope, response);
				break;
			case "load":
				this.loadErr($scope, response);
				break;
			case "show":
				this.showErr($scope, response);
				break;
		}
	}
	
	this.authOk = function($scope, response){
		$keyboardMonster.init();
		$location.path("/main");					//go to main and show mainActivity
		Log.d("NEWS_COUNT", response.data.news_count);
		$navView.setNewsCount(parseInt(response.data.news_count, 10));
		//response.data.news_count
	}
	
	this.authErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_BROWSER_AUTH:
				$dialogView.showToast($dialogView.strings.loginFail);
				break;
			case Constant.ERR_CODE_CONNECTOR_AUTH:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
			case Constant.ERR_CODE_BROWSER_INFO:
				$dialogView.showToast($dialogView.strings.readErr);
				break;
			case Constant.ERR_CODE_DATA_SAVE:
				Log.d("ERR_CODE_DATA_SAVE", "ERR_CODE_DATA_SAVE");
				//$dialogView.showToast($dialogView.strings.writeErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.loadOk = function($scope, response){
		//nothing to do here
	}
	
	this.loadErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_DATA_LOAD:
				//nothing to do here
				break;
		}
	}

	//init all functions in view
	this.initViewParams = function(){
		// hide go to earn button
		$(".goearn-but-block").css("display", "none");
		
		// hide navigation bar
		$(".navigation").addClass("none");
	}
}]);