Lang.getSettings = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				settingsText: "Settings",
				newVersionText: "A new version: ",
				updateButText: "Update",
				premiumAccText: "Premium account",
				followEarnText: "Follow in earning",
				autoEarnText: "Auto mining after authorization",
				notifActiveText: "Notifications",
				notifSoundText: "Notification sound",
				guideText: "Tutorial",
				rateText: "Rate the application",
				otherAppText: "Others our applications:",
				privacyText: "User aggreement",
				exitAccText: "Log out"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				settingsText: "Настройки",
				newVersionText: "Новая версия: ",
				updateButText: "Обновить",
				premiumAccText: "Премиум аккаунт",
				followEarnText: "Подписка в заработке",
				autoEarnText: "Автоматическая добыча при авторизации",
				notifActiveText: "Уведомления",
				notifSoundText: "Звук уведомлений",
				guideText: "Руководство",
				rateText: "Оцените приложение",
				otherAppText: "Другие наши приложения:",
				privacyText: "Пользовательское соглашение",
				exitAccText: "Выйти из аккаунта"
			};
			break;
		case Constant.DE_LANG:
			lang = {
				settingsText: "Einstellungen",
				newVersionText: "neue Version: ",
				updateButText: "Auffrischen",
				premiumAccText: "Premium account",
				followEarnText: "Erwerbsubskription",
				autoEarnText: "Automatischer Erwerb bei der Authorisierung",
				notifActiveText: "Benachrichtigungen",
				notifSoundText: "Benachrichtigungston",
				guideText: "Anleitung",
				rateText: "bewerten Sie die App",
				otherAppText: "unsere andere App:",
				privacyText: "Nutzungsvereinbarung",
				exitAccText: "aus dem Account raus sein"
			};
			break;
		case Constant.ES_LANG:
			lang = {
				settingsText: "Las configuraciones",
				newVersionText: "La version nueva: ",
				updateButText: "Renovar",
				premiumAccText: "El perfil premium",
				followEarnText: "La suscripcion en el salario",
				autoEarnText: "La extraccion automatica durante la autorizacion",
				notifActiveText: "Notificaciones",
				notifSoundText: "Sonido de notificación",
				guideText: "Guia",
				rateText: "Estime la la aplicacion",
				otherAppText: "Otras nuestras aplicaciones:",
				privacyText: "El acuerdo del usario",
				exitAccText: "Salir del perfil"
			};
			break;
		case Constant.FR_LANG:
			lang = {
				settingsText: "Configurations",
				newVersionText: "Mise a jour:  ",
				updateButText: "Mettre a jour",
				premiumAccText: "Premium",
				followEarnText: "Abonnement en gain",
				autoEarnText: "Gain automatique en cas d'autorisation",
				notifActiveText: "Notifications",
				notifSoundText: "Son de notification",
				guideText: "Guide",
				rateText: "Evaluez l'application",
				otherAppText: "Nos autres applications:",
				privacyText: "Accord de l'utilisateur",
				exitAccText: "Se deconnecter du compte"
			};
			break;
		case Constant.IT_LANG:
			lang = {
				settingsText: "impostazioni",
				newVersionText: "nuova versione: ",
				updateButText: "aggiornare",
				premiumAccText: "Premium account",
				followEarnText: "iscrizione ai guadagni",
				autoEarnText: "la produzione automatica avendo l'autorizzazione",
				notifActiveText: "Notifiche",
				notifSoundText: "Suono di notifica",
				guideText: "la guida",
				rateText: "valuta l'app",
				otherAppText: "le altre nostre app:",
				privacyText: "condizioni d'uso",
				exitAccText: "uscire dall'account"
			};
			break;
		case Constant.TR_LANG:
			lang = {
				settingsText: "Ayarlar",
				newVersionText: "Yeni versiyonu: ",
				updateButText: "Yenile",
				premiumAccText: "Premium hesap",
				followEarnText: "Abone işlem yapıyor",
				autoEarnText: "Otomatik çıkarma yetkisi",
				notifActiveText: "Bildirimler",
				notifSoundText: "Bilgilendirme sesi",
				guideText: "Başlık",
				rateText: "Programa ses ver",
				otherAppText: "Diğer programlarımız:",
				privacyText: "Kullanıcı Sözleşmesi",
				exitAccText: "Hesabınıza çıkın"
			};
			break;
	}
	return lang;
}

// SETTINGS LANGS
services_lang.service("$settingsLang", ["$lang", function($lang){
	this.setLang = function($scope){
		$lang.getLang(Constant.SETTINGS_VIEW, function(lang){
			$scope.settingsText = lang.settingsText;
			$scope.newVersionText = lang.newVersionText;
			$scope.updateButText = lang.updateButText;
			$scope.premiumAccText = lang.premiumAccText;
			$scope.followEarnText = lang.followEarnText;
			$scope.autoEarnText = lang.autoEarnText;
			$scope.notifActiveText = lang.notifActiveText;
			$scope.notifSoundText = lang.notifSoundText;
			$scope.guideText = lang.guideText;
			$scope.rateText = lang.rateText;
			$scope.otherAppText = lang.otherAppText;
			$scope.privacyText = lang.privacyText;
			$scope.exitAccText = lang.exitAccText;

			$scope.$applyAsync();
		});
	}
}]);