services_views.service("$settingsView", ["$manager", "$window", "$location", "$dialogView", "$demon", "$keyboardMonster", "$heighter", 
					function($manager, $window, $location, $dialogView, $demon, $keyboardMonster, $heighter){
	var self = this;
	
	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "logout":
				this.logoutOk($scope, response);
				break;
			case "version":
				this.versionOk($scope, response);
				break;
			case "apps":
				this.appsOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "logout":
				this.logoutErr($scope, response);
				break;
		}
	}

	this.logoutOk = function($scope, response){
		$demon.stopNewsDemon();
		$demon.stopFastEarnDemon();
		$demon.stopAutoTaskDemon();
		$(".goearn-but-block").css("display", "none");
		$keyboardMonster.clear();
		$location.path("/login");					//go to main and show mainActivity
	}

	this.logoutErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_BROWSER_LOGOUT:
				$dialogView.showToast($dialogView.strings.readErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_LOGOUT:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
			case Constant.ERR_CODE_DATA_CLEAR:
				$dialogView.showToast($dialogView.strings.writeErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	this.versionOk = function($scope, response){
		var curV = $manager.instance.getAppVersion().split(".").join("");
		var newV = response.data.version.split(".").join("");
		if(parseInt(curV) < parseInt(newV)){
			$scope.versionText = $scope.newVersionText + response.data.version;
			$(".settings-version:first").removeClass("none");
		}
	}

	// set our applications
	this.appsOk = function($scope, response){
		$scope.apps = response.data.apps;

		if(response.data.apps.length > 0){
			if($manager.instance.getUser().isSafeUser()){
				$(".settings-otherapp-block:first").removeClass("none");
				$(".settings-rate-forborder").each(function(){
					$(this).addClass("settings-bottom-border");
				});
			}
		}
	}
	
	// open social links or send mail
	this.openService = function(service){
		switch(service){
			case "this":
				if(Constant.CUR_DEVICE == Constant.ANDROID_DEVICE){
					navigator.app.loadUrl('https://play.google.com/store/apps/details?id=' + Constant.APP_PACKAGE, {openExternal : true});
				}else{
					$window.open('https://itunes.apple.com/ru/app/' + Constant.APP_STRING_IOS_NAME + '/' + Constant.APP_STRING_IOS_ID, '_service', 'location=yes');
				}
				break;
			case "mail":
				if(Constant.CUR_DEVICE == Constant.ANDROID_DEVICE){
					navigator.app.loadUrl("mailto:" + Constant.MAIL, {openExternal : true});
				}else{
					$window.plugins.emailComposer.showEmailComposer("", "", [Constant.MAIL]);
				}
				break;
			case "vk":
				if(Constant.CUR_DEVICE == Constant.ANDROID_DEVICE){
					navigator.app.loadUrl('https://vk.com/ruboss_tech', {openExternal : true});
				}else{
					$window.open('https://vk.com/ruboss_tech', '_service', 'location=yes');
				}
				break;
			case "fb":
				if(Constant.CUR_DEVICE == Constant.ANDROID_DEVICE){
					navigator.app.loadUrl('https://www.facebook.com/ruboss.tech', {openExternal : true});
				}else{
					$window.open('https://www.facebook.com/ruboss.tech', '_service', 'location=yes');
				}
				break;
			case "tw":
				if(Constant.CUR_DEVICE == Constant.ANDROID_DEVICE){
					navigator.app.loadUrl('https://twitter.com/ruboss_tech', {openExternal : true});
				}else{
					$window.open('https://twitter.com/ruboss_tech', '_service', 'location=yes');
				}
				break;
			case "tg":
				if(Constant.CUR_DEVICE == Constant.ANDROID_DEVICE){
					navigator.app.loadUrl('https://telegram.me/ruboss', {openExternal : true});
				}else{
					$window.open('https://telegram.me/ruboss', '_service', 'location=yes');
				}
				break;
		}
	}

	// turn on guide
	this.watchGuide = function($scope){
		$manager.instance.getDataManager().setSetting(Config.FIRSTTIME_SETTING, 1, function(){
			$location.path("/main");
			$scope.$applyAsync();
		});
	}

	// set link on every our applications
	this.getLinkOnApp = function(appId){
		navigator.app.loadUrl("https://play.google.com/store/apps/details?id=" + appId, {openExternal : true});
	}

	this.showPrivacy = function(){
		$location.path("/privacy");
	}

	function setPremiumSwitcher(){
		setFollowingSwitcher();
		if($manager.instance.getUser().getPremium()){
			$("#premBut").css("background-image", "url(images/switcher_active.png)");
			$("#premFollBlock").removeClass("settings-content-elem-disable");
			
			$("#premBut").parent().click(function(){
				return false;
			});
			
			$("#premFollBut").click(function(){
				var val = $manager.instance.getUser().getSetting(Config.SUBSCRIBE_SETTING) == 1 ? 0 : 1;
				$manager.instance.getDataManager().setSetting(Config.SUBSCRIBE_SETTING, val, function(){
					setFollowingSwitcher();
				});
			});
		}

		function setFollowingSwitcher(){
			if($manager.instance.getUser().getSetting(Config.SUBSCRIBE_SETTING) == 1){
				$("#premFollBut").css("background-image", "url(images/switcher_active.png)");
			}else{
				$("#premFollBut").css("background-image", "url(images/switcher_inactive.png)");
			}
		}
	}

	function setAutoEarnSwitcher(){
		setAutoEarnBut($manager.instance.getUser().getSetting(Config.AUTOEARN_SETTING));

		$("#autoEarnBut").click(function(){
			var val = $manager.instance.getUser().getSetting(Config.AUTOEARN_SETTING) == 1 ? 0 : 1;
			$manager.instance.getDataManager().setSetting(Config.AUTOEARN_SETTING, val, function(){
				setAutoEarnBut(val);
			});
		});

		function setAutoEarnBut(isOn){
			if(isOn){
				$("#autoEarnBut").css("background-image", "url(images/switcher_active.png)");
			}else{
				$("#autoEarnBut").css("background-image", "url(images/switcher_inactive.png)");
			}
		}
	}

	function setNotifActiveSwitcher(){
		setNotifActiveBut($manager.instance.getUser().getSetting(Config.NOTIFICATION_ACTIVE_SETTING));

		$("#notifActiveBut").click(function(){
			var val = $manager.instance.getUser().getSetting(Config.NOTIFICATION_ACTIVE_SETTING) == 1 ? 0 : 1;
			$manager.instance.getDataManager().setSetting(Config.NOTIFICATION_ACTIVE_SETTING, val, function(){
				setNotifActiveBut(val);
			});
		});

		function setNotifActiveBut(isOn){
			if(isOn){
				$("#notifActiveBut").css("background-image", "url(images/switcher_active.png)");
			}else{
				$("#notifActiveBut").css("background-image", "url(images/switcher_inactive.png)");
			}
		}
	}

	function setNotifSoundSwitcher(){
		setNotifSoundBut($manager.instance.getUser().getSetting(Config.NOTIFICATION_SETTING));

		$("#notifSoundBut").click(function(){
			var val = $manager.instance.getUser().getSetting(Config.NOTIFICATION_SETTING) == 1 ? 0 : 1;
			$manager.instance.getDataManager().setSetting(Config.NOTIFICATION_SETTING, val, function(){
				setNotifSoundBut(val);
			});
		});

		function setNotifSoundBut(isOn){
			if(isOn){
				$("#notifSoundBut").css("background-image", "url(images/switcher_active.png)");
			}else{
				$("#notifSoundBut").css("background-image", "url(images/switcher_inactive.png)");
			}
		}
	}

	function setContentSize(){
		$(".settings-block").css("height", $heighter.setHeight(Constant.MINOR_VIEW));
	}

	//init all functions in view
	this.initViewParams = function(){
		// hide go to earn button
		$(".goearn-but-block").css("display", "none");

		// hide navigation bar
		$(".navigation").addClass("none");

		// set height of main content
		setContentSize();

		// set premium and subscribe settings
		setPremiumSwitcher();
		// set auto earn settings
		setAutoEarnSwitcher();
		// set notification active settings
		setNotifActiveSwitcher();
		// set notification sound settings
		setNotifSoundSwitcher();
	}
}]);