Lang.getTop = function(lang_code){
	var lang = null;
	switch(lang_code){
		case Constant.EN_LANG:
			lang = {
				backText: "Rating",
				prizeTimeText: "The competition will end after:",
				tasksCompleteText: "Completed tasks:",
				dialogText: "Mine diamonds, take top places and get prizes",
				dialogPlaceText: "Place",
				dialogButText: "Ok"
			};
			break;
		case Constant.RU_LANG:
			lang = {
				backText: "Рейтинг",
				prizeTimeText: "До выдачи призов осталось:",
				tasksCompleteText: "Заданий выполнено:",
				dialogText: "Добывайте диаманты, занимайте призовые места в рейтинге и получайте призы",
				dialogPlaceText: "Место",
				dialogButText: "Ок"
			};
			break;
		case Constant.DE_LANG:
			lang = {
				backText: "Stellenwert",
				prizeTimeText: "Bis zur Preisverteilung blieb es:",
				tasksCompleteText: "erledigte Aufgaben:",
				dialogText: "Erwerben Sie Diamanten, belegen Sie Preisplaetze im Stellenwert und beommen Sie Preise",
				dialogPlaceText: "Platz",
				dialogButText: "Ok"
			};
			break;
		case Constant.ES_LANG:
			lang = {
				backText: "Valoracion",
				prizeTimeText: "Hasta la expedicion de las sorpresas deja:",
				tasksCompleteText: "Las tareas realizadas:",
				dialogText: "Extraed los diamantes, ocupad los puestos premiados",
				dialogPlaceText: "Puesto",
				dialogButText: "Ok"
			};
			break;
		case Constant.FR_LANG:
			lang = {
				backText: "Classement",
				prizeTimeText: "On distribuera des prix dans:",
				tasksCompleteText: "Taches accomplies:",
				dialogText: "Gagnez des diamants, occupez les premieres places du classement et remportez des prix",
				dialogPlaceText: "Place",
				dialogButText: "Ok"
			};
			break;
		case Constant.IT_LANG:
			lang = {
				backText: "valutazione",
				prizeTimeText: "al rilascio dei premi mancano:",
				tasksCompleteText: "la domanda posta:",
				dialogText: "produci diamanti, occupate i primi posti e ricevete i premi",
				dialogPlaceText: "posto",
				dialogButText: "Ok"
			};
			break;
		case Constant.TR_LANG:
			lang = {
				backText: "Reyting",
				prizeTimeText: "Ödüllerin verilmesine kaldı:",
				tasksCompleteText: "Görev tamamlandı:",
				dialogText: "Elmas üretmek sıralamasında üst yerleri işgal ve ödül kazanmak",
				dialogPlaceText: "Yer",
				dialogButText: "Ok"
			};
			break;
	}

	// common place's text in top
	lang.dialogPlace1Text = Constant.TOP_PLACE_FIRST;
	lang.dialogPlace2Text = Constant.TOP_PLACE_SECOND;
	lang.dialogPlace3Text = Constant.TOP_PLACE_THIRD;
	lang.dialogPlace4Text = Constant.TOP_PLACE_FOURTH;
	lang.dialogPlace5Text = Constant.TOP_PLACE_FIFTH;

	// common prize's text in top
	lang.dialogFirstNum = Constant.TOP_PLACE_FIRST_NUM;
	lang.dialogSecondNum = Constant.TOP_PLACE_SECOND_NUM;
	lang.dialogThirdNum = Constant.TOP_PLACE_THIRD_NUM;
	lang.dialogFourthNum = Constant.TOP_PLACE_FOURTH_NUM;
	lang.dialogFifthNum = Constant.TOP_PLACE_FIFTH_NUM;

	return lang;
}

// TOP LANGS
services_lang.service("$topLang", ["$lang", function($lang){
	this.setLang = function($scope){
		$lang.getLang(Constant.TOP_VIEW, function(lang){
			$scope.backText = lang.backText;
			$scope.prizeTimeText = lang.prizeTimeText;
			$scope.tasksCompleteText = lang.tasksCompleteText;
			$scope.dialogText = lang.dialogText;
			$scope.dialogPlaceText = lang.dialogPlaceText;

			$scope.dialogPlace1Text = lang.dialogPlace1Text;
			$scope.dialogPlace2Text = lang.dialogPlace2Text;
			$scope.dialogPlace3Text = lang.dialogPlace3Text;
			$scope.dialogPlace4Text = lang.dialogPlace4Text;
			$scope.dialogPlace5Text = lang.dialogPlace5Text;

			$scope.dialogFirstNum = lang.dialogFirstNum;
			$scope.dialogSecondNum = lang.dialogSecondNum;
			$scope.dialogThirdNum = lang.dialogThirdNum;
			$scope.dialogFourthNum = lang.dialogFourthNum;
			$scope.dialogFifthNum = lang.dialogFifthNum;
			
			$scope.dialogButText = lang.dialogButText;

			$scope.$applyAsync();
		});
	}
}]);