services_views.service("$topView", ["$manager", "$dialogView", "$heighter", function($manager, $dialogView, $heighter){
	var timer;
	var self = this;
	
	this.manageView = function($scope, response){
		if(response.status == Constant.OK_STATUS){
			this.okView($scope, response);
		}else{
			this.errView($scope, response);
		}
		$scope.$applyAsync();
	}
	
	this.okView = function($scope, response){
		switch(response.action){
			case "top":
				this.topOk($scope, response);
				break;
		}
	}
	
	this.errView = function($scope, response){
		switch(response.action){
			case "top":
				this.topErr($scope, response);
				break;
		}
	}
	
	this.topOk = function($scope, response){
		$scope.tops = response.data.tops;

		// set time before the end of competition
		setTimer(response.data.left);

		// set user info in competition
		setTopUserInfo($scope, response.data.place);
	}
	
	this.topErr = function($scope, response){
		switch(response.data.errorCode){
			case Constant.ERR_CODE_CONNECTOR_TOP:
				$dialogView.showToast($dialogView.strings.readErr);
				break;
			case Constant.ERR_CODE_CONNECTOR_CONNECTION:
				$dialogView.showToast($dialogView.strings.connectErr);
				break;
		}
	}
	
	// show dialog with prizes in top
	this.showHelpDialog = function(){
		$(".top-dialog-block:first").removeClass("none");
	}
	
	// hide dialog with prizes in top
	this.hideHelpDialog = function(){
		$(".top-dialog-block:first").addClass("none");
	}

	this.clearTimer = function(){
		clearInterval(timer);
	}

	function setTimer(seconds){
		var numsec = seconds;
		var ONE_HOUR = 3600;
		var ONE_MINUTE = 60;

		setTime();

		timer = setInterval(function(){
			if(numsec < 0)
				numsec = 86399;
			setTime();
		}, 1000);

		function getTime(){
			var hours = parseInt(numsec / ONE_HOUR);
			var mins = parseInt((numsec - (hours * ONE_HOUR)) / ONE_MINUTE);
			var secs = parseInt((numsec - (hours * ONE_HOUR)) - (mins * ONE_MINUTE));

			return setNull(hours) + ":" + setNull(mins) + ":" + setNull(secs);
		}

		function setTime(){
			$(".top-time:first").text(getTime());
			numsec--;
		}

		function setNull(num){
			return (num > 9) ? num : "0"+num;
		}
	}

	function setTopUserInfo($scope, place){
		// set nickname in userpos
		$scope.userposNick = $manager.instance.getUser().getNick();
		// set place in userpos
		$scope.userposPlace = place;

		// if 1-5 place so don't show usertop
		if(place > 0 && place < 6){
			setContentSize(1);
		}else{
			$(".top-userpos").removeClass("none");
			setContentSize(2);
		}
	}

	function setContentSize(num){
		switch(num){
			case 1:
				$(".top-block").css("height", $heighter.setHeight(Constant.MINOR_VIEW, [$(".top-time-block")]));
				break;
			case 2:
				$(".top-block").css("height", $heighter.setHeight(Constant.MINOR_VIEW, [$(".top-time-block"), $(".top-userpos")]));
				break;
		}
	}

	function cancelEvents(){
		$(".top-dialog-block").bind("scroll touchmove", function(e){
			e.preventDefault();
		});

		$(".top-dialog-content:first").click(function(){
			return false;
		});
	}

	//init all functions in view
	this.initViewParams = function(){
		// hide go to earn button
		$(".goearn-but-block").css("display", "none");

		// hide navigation bar
		$(".navigation").addClass("none");
		
		// cancel events on page
		cancelEvents();
	}
}]);