services.service("$manager", ["$rootScope", function($rootScope){
	this.instance = new Manager($rootScope);
}]);

services.service("$action",["$manager", "$saver", function($manager, $saver){
	var self = this;

	this.bid = function($scope, bid){
		$manager.instance.getBrowser().getMetaHead(bid, function(dataBrowser){		//check page for valid
			if(dataBrowser != null && dataBrowser.status == Constant.OK_STATUS){
				if(!dataBrowser.is_private){
					bid.setMeta(dataBrowser.metaHead.meta);
					bid.setHead(dataBrowser.metaHead.head);
					bid.setId(dataBrowser.metaHead.id);
					$manager.instance.getConnector().bid(bid, function(result){	//try to add
						if(result.status == Constant.OK_STATUS){
							$saver.clear("tasks");
							$manager.instance.getUser().setCash(result.cash);
							$scope.response({action: "bid", status: Constant.OK_STATUS, data: {cash: result.cash}});
						}else if(result.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
							$scope.response({action: "bid", status: Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
						}else{
							$scope.response({action: "bid", status: Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_BID}});
						}
					});
				}else{
					$scope.response({action: "bid", status: Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BROWSER_PRIVATE}});
				}
			}else{
				$scope.response({action: "bid", status: Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BROWSER_BID}});
			}
		});
	}

	this.bidList = function($scope, bidInfo){
		$manager.instance.getConnector().bidList(bidInfo, function(result){	//try to add
			if(result.status == Constant.OK_STATUS){
				$saver.clear("tasks");
				$manager.instance.getUser().setCash(result.cash);
				$scope.response({action: "bidList", status: Constant.OK_STATUS, data: {cash: result.cash}});
			}else if(result.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
				$scope.response({action: "bidList", status: Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}else{
				$scope.response({action: "bidList", status: Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_BID}});
			}
		});
	}
	
	this.tasks = function($scope){
		var saverStat = $saver.load("tasks");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "tasks", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getConnector().getTasks(function(dataConnector){
				if(dataConnector.status == Constant.OK_STATUS){
					$saver.saveSpec("tasks", {tasks: dataConnector.tasks}, 5);
					$scope.response({action: "tasks", status: Constant.OK_STATUS, data: {tasks: dataConnector.tasks}});
				}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
					$scope.response({action: "tasks", status: Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
				}else{
					$scope.response({action: "tasks", status: Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_TASKS}});
				}
			});
		}
	}
	
	this.version = function($scope){
		var saverStat = $saver.load("version");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "version", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getConnector().version(function(dataConnector){
				//only if ok status
				if(dataConnector.status == Constant.OK_STATUS){
					$saver.saveSpec("version", {version: dataConnector.version}, 3600);
					$scope.response({action: "version", status:Constant.OK_STATUS, data: {version: dataConnector.version}});
				}
			});
		}
	}
	
	this.apps = function($scope){
		var saverStat = $saver.load("apps");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "apps", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getConnector().apps(function(dataConnector){
				//only if ok status
				if(dataConnector.status == Constant.OK_STATUS){
					$saver.saveSpec("apps", {apps: dataConnector.apps}, 3600);
					$scope.response({action: "apps", status:Constant.OK_STATUS, data: {apps: dataConnector.apps}});
				}
			});
		}
	}
	
	this.top = function($scope){
		var saverStat = $saver.load("top");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "top", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getConnector().getTop(function(dataConnector){
				if(dataConnector.status == Constant.OK_STATUS){
					$saver.saveSpec("top", dataConnector, 60);
					$scope.response({action: "top", status:Constant.OK_STATUS, data: dataConnector});
				}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
					$scope.response({action: "top", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
				}else{
					$scope.response({action: "top", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_TOP}});
				}
			});
		}
	}

	this.getUserInfo = function($scope, user){
		$manager.instance.getBrowser().getUserInfo(user, function(dataBrowser){	//get UserInfo
			if(dataBrowser != null){
				$scope.response({action: "getUserInfo", status:Constant.OK_STATUS, data: dataBrowser.userInfo});
			}else{
				$scope.response({action: "getUserInfo", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}
		});
	}
	
	this.news = function($scope){
		var saverStat = $saver.load("news");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "news", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getConnector().watchAllNews(function(response){
				if(response.status == Constant.OK_STATUS){
					$manager.instance.getConnector().getNews(function(dataConnector){
						if(dataConnector.status == Constant.OK_STATUS){
							$saver.saveSpec("news", {news: dataConnector.news}, 60);
							$scope.response({action: "news", status:Constant.OK_STATUS, data: {news: dataConnector.news}});
						}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
							$scope.response({action: "news", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
						}else{
							$scope.response({action: "news", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_NEWS}});
						}
					});
				}else if(response.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
					$scope.response({action: "news", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
				}
				else{
					$scope.response({action: "news", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_NEWS}});
				}
			});
		}
	}
	
	this.complete = function(name, id, message, value, $scope){
		$manager.instance.getConnector().setComplete(name, id, value, function(dataConnector){
			if(dataConnector.status == Constant.OK_STATUS){
				$saver.clear("news");
				$scope.response({action: "complete", status:Constant.OK_STATUS, data: {cash: dataConnector.cash, name: name, message: message,
					achieves: dataConnector.achieves, premium: dataConnector.premium, turbo: dataConnector.turbo}});
			}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
				$scope.response({action: "complete", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}else{
				$scope.response({action: "complete", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_COMPLETE}});
			}
		});
	}
	
	this.run = function($scope, type){
		$manager.instance.getBot().run(function(result){
			if(result == Constant.OK_STATUS){
				$scope.response({action: "run", status:Constant.OK_STATUS, type: type, data: {}});
			}else{
				$scope.response({action: "run", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BOT_RUN}});
			}
		});
	}

	this.setMode = function($scope){
		$manager.instance.getBot().setMode(Bot.FAST_EARN_MODE, function(result){
			if(result == Constant.OK_STATUS){
				$manager.instance.getConnector().fastEarn(function(){});
				//$scope.response({action: "setMode", status:Constant.OK_STATUS, data: {}});
			}else{
				//$scope.response({action: "setMode", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BOT_RUN}});
			}
		});
	}
	
	this.stop = function($scope){
		$manager.instance.getBot().stop(function(result){
			if(result == Constant.OK_STATUS){
				$scope.response({action: "stop", status:Constant.OK_STATUS, data: {}});
			}else{
				$scope.response({action: "stop", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BOT_STOP}});
			}
		});
	}
	
	this.deleteTask = function($scope, task){
		$manager.instance.getConnector().deleteTask(task.getId(), task.getType(), function(result){
			if(result.status == Constant.OK_STATUS){
				$saver.clear("tasks");
				$manager.instance.getUser().setCash(result.cash);
				$scope.response({action: "delete", status:Constant.OK_STATUS, data: {task:task, cash: result.cash}});
			}else if(result.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
				$scope.response({action: "delete", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}else{
				$scope.response({action: "delete", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_DELETE}});
			}
		});
	}

	this.refreshTask = function($scope, task){
		$manager.instance.getConnector().refreshTask(task.getId(), task.getType(), function(result){
			if(result.status == Constant.OK_STATUS){
				$saver.clear("tasks");
				$scope.response({action: "refresh", status:Constant.OK_STATUS, data: {task:task}});
			}else if(result.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
				$scope.response({action: "refresh", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}else{
				$scope.response({action: "refresh", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_DELETE}});
			}
		});
	}
	
	this.moreFields = function(user, $scope){						//Main scope
		$manager.instance.getBrowser().moreFields(user, function(dataBrowser){	//update browser
			if(dataBrowser != null){
				user.addMorePosts(dataBrowser.moreInfo);
				$scope.response({action: "moreFields", status:Constant.OK_STATUS, data: {moreInfo: dataBrowser.moreInfo}});
			}else{
				$scope.response({action: "moreFields", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BROWSER_UPDATE}});
			}
		});
	}
}]);

services.service("$auth",["$manager", "$dialogView", "$demon", "$way", "$saver", function($manager, $dialogView, $demon, $way, $saver){
	var self = this;
	this.load = function($scope){

		$manager.instance.getDataManager().loadAuthData(function(dataManager){				//try to load login data from files
			if(dataManager.status == Constant.OK_STATUS){									//we found something
			}else{
				$scope.response({action: "load", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_DATA_LOAD}});
			}
		});
	}
	
	this.auth = function($scope){							//login scope
		tryAuth($scope, $manager);
	}
	
	var tryAuth = function($scope, $manager){
		$manager.instance.getBrowser().auth(function(result){			//try auth with login data
			if(result == Constant.OK_STATUS){								//auth good
				self.getInfo($scope);
			}else if(result == Constant.ERR_CODE_BROWSER_REINIT){
				$dialogView.showLoading();
				$manager.instance.getBrowser().init(function(response){
					tryAuth($scope, $manager);
				});
			}else if(result == Constant.ERR_CODE_BROWSER_CLOSED){
				$manager.instance.getBrowser().init(function(response){
					if(response == Constant.OK_STATUS_IN){
						self.getInfo($scope);
					}else{
						$dialogView.hideLoading();
					}
				});
			}else if(response == Constant.ERR_STATUS){
				$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}
		});
	}
	
	this.preload = function($scope){
		var sel = this;
		$manager.instance.getBrowser().init(function(response){
			$dialogView.hideInitLoading();
			$dialogView.showLoading();
			if(response == Constant.OK_STATUS_IN){
				self.getInfo($scope);
			}else if(response == Constant.OK_STATUS){
				$dialogView.hideLoading();
			}else if(response == Constant.ERR_STATUS){
				$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
			}
		});
	}
	
	this.getInfo = function($scope){
		$manager.instance.getBrowser().getUserInfo($manager.instance.getUser(), function(dataBrowser){	//get UserInfo
			if(dataBrowser != null){
				$manager.instance.getUser().setUserInfo(dataBrowser.userInfo);	//set user info
				$manager.instance.getDataManager().loadAuthData(function(dataManager){				//try to load login data from files
					
					var authData = new AuthData(dataBrowser.userInfo.nick, "", 0);
					
					if(dataManager.status == Constant.OK_STATUS){									//we found something
						//if logins not equal
						if(authData.getLogin() != dataManager.authData.getLogin()){
							authData.setOldLogin(dataManager.authData.getLogin());
							authData.setNeedUpdate(1);
						}
					}
					
					$manager.instance.getUser().setAuthData(authData);
					
					$manager.instance.getConnector().auth(function(dataConnector){	//connect to server and get valid token
						if(dataConnector.status == Constant.OK_STATUS){
							var user = $manager.instance.getUser();
							user.setCash(dataConnector.cash);	//set new data
							user.setConfig(dataConnector.config);
							user.setXpInfo(dataConnector.xp_info);
							$way.refresh();
							user.setPremium(dataConnector.premium);
							user.setTurbo(dataConnector.turbo);
							user.setRtime(dataConnector.rtime);
							user.setAchieves(dataConnector.achieves);
							user.setId(dataConnector.id);
							user.setBalance(dataConnector.balance);
							user.setFastReady(dataConnector.delay);
							user.setNeedData(dataConnector.need_data);
							$manager.instance.getDataManager().saveAuthData(authData, function(saveManager){			//save to storage
								//if(saveManager.status == Constant.OK_STATUS){
									
									var val = $manager.instance.getUser().getSetting(Config.AUTOEARN_SETTING) == 1 ? true : false;
									//run bot if setting is ON and user come not first time
									if(val && !$manager.instance.getUser().isFirstTime()){
										$manager.instance.getBot().run(function(result){
											
										});
									}
									//$demon.startPayDemon();
				
									$scope.response({action: "auth", status:Constant.OK_STATUS, data: {news_count: dataConnector.news_count}});
								//}else{
								//	$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_DATA_SAVE}});
								//}
							});
						}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
							$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
						}else{
							$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_AUTH}});
						}
					});
				});
			}else{
				$scope.response({action: "auth", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BROWSER_INFO}});
			}
		});
	}
	
	this.update = function($scope){						//Main scope
		var saverStat = $saver.load("update");
		if(saverStat.status == Constant.OK_STATUS){
			$scope.response({action: "update", status:Constant.OK_STATUS, data: saverStat.data});
		}else{
			$manager.instance.getBrowser().update(function(dataBrowser){	//update browser
				if(dataBrowser != null){
					$manager.instance.getUser().setUserInfo(dataBrowser.userInfo);
					$manager.instance.getConnector().update(function(dataConnector){	//update connector
						if(dataConnector.status == Constant.OK_STATUS){
							$manager.instance.getUser().setAuthData(dataConnector.authData);
							$manager.instance.getUser().setCash(dataConnector.cash);
							$manager.instance.getUser().setAchieves(dataConnector.achieves);
							$manager.instance.getUser().setXpInfo(dataConnector.xp_info);
							$manager.instance.getUser().setPremium(dataConnector.premium);
							$manager.instance.getUser().setTurbo(dataConnector.turbo);
							$manager.instance.getUser().setBalance(dataConnector.balance);
							$saver.saveSpec("update", {premium: dataConnector.premium, turbo: dataConnector.turbo}, 5);
							$scope.response({action: "update", status:Constant.OK_STATUS, data: dataConnector});
						}else if(dataConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
							$scope.response({action: "update", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
						}else{
							$scope.response({action: "update", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_UPDATE}});
						}
					});
				}else{
					$scope.response({action: "update", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BROWSER_UPDATE}});
				}
			});
		}
	}
	
	this.logout = function($scope){
		$manager.instance.getBot().stop(function(response){
			;//response
		});
		$manager.instance.getBrowser().logout(function(resultBrowser){				//logout from browser
			if(resultBrowser == Constant.OK_STATUS){
				$manager.instance.getConnector().logout(function(resultConnector){	//logout from connector
					if(resultConnector.status == Constant.OK_STATUS){
						$manager.instance.getDataManager().clearAuthData(function(resultManager){		//clear data
							if(resultManager.status == Constant.OK_STATUS){
								$manager.instance.getUser().reset();		//reset user
								$way.refresh();
								$scope.response({action: "logout", status:Constant.OK_STATUS, data: {}});
							}else{
								$scope.response({action: "logout", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_DATA_CLEAR}});
							}
						});
					}else if(resultConnector.status == Constant.ERR_CODE_CONNECTOR_CONNECTION){
						$scope.response({action: "logout", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_CONNECTION}});
					}else{
						$scope.response({action: "logout", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_CONNECTOR_LOGOUT}});
					}
				});
			}else{
				$scope.response({action: "logout", status:Constant.ERR_STATUS, data: {errorCode: Constant.ERR_CODE_BROWSER_LOGOUT}});
			}
		});
	}
}]);